// -----------------------------------------------------------------------------------------
//
// umFish20.H                                                         Ulrich Mller   9.3.00
//                                                                    Procida 400NT VC++ 6.0
//
// -----------------------------------------------------------------------------------------

typedef struct {
  HANDLE  hCom;              // --- Handle : COM1-9       ------- HANDLE / OpenFlag --------
	                           //     Handle : LPT1-3 Win9x
	                           //     1      : LPT Win9x
	                           //     hWinRT : LPT WinNT
	                           //     0      : noch nicht geffnet oder Close
	DWORD  PortID;             // --- 0      : COM          ---- IO-Adresse / InterfaceType --
	                           //     1      : LPT WinNT
	                           //     Adr    : LPT Win9x  
	DWORD  LPTDelay;           // --- LPT Verzgerungsfaktor
	DWORD  LPTAnalog;          // --- LPT Analogfaktor 
	DWORD  ECount;             // --- Slave Anzahl Eingnge 8 / 16
	
	MMRESULT FID;              // --- Handle : MultiaMediaTimer
	DWORD    PollInterval;     //     PollInterval des MM-Timers in mSek
  DWORD    AnalogScan;       //     Pollen auch der A-Eingnge (0, 1, 2)

	DWORD  OutputStatus;       // --- Status der M-Ausgnge
	DWORD  InputStatus;        //     Status der E-Eingnge
	DWORD  Analogs[2];         //     Werte der A-Eingnge
	DWORD  Counters[16];       //     Impulszhler an den E-Eingngen 
} ftiDCB;

const DWORD ftiAus    = 0;
const DWORD ftiEin    = 1;
const DWORD ftiLinks  = 1;
const DWORD ftiRechts = 2;

const DWORD ftiFehler = 0x0001FFFF;

const DWORD MAus[9]      = {0, 0xFFFC, 0xFFF3, 0xFFCF, 0xFF3F,
														   0xFCFF, 0xF3FF, 0xCFFF, 0x3FFF};
const DWORD MLinks[9]    = {0, 0x1,    0x4,    0x10,   0x40,
                               0x100,  0x400,  0x1000, 0x4000};
const DWORD MRechts[9]   = {0, 0x2,    0x8,    0x20,   0x80,
                               0x200,  0x800,  0x2000, 0x8000};
const DWORD EMaske[17]   = {0, 0x1,    0x2,    0x4,    0x8,
                               0x10,   0x20,   0x40,   0x80,
                               0x100,  0x200,  0x400,  0x800,
                               0x1000, 0x2000, 0x4000, 0x8000}; 

enum erFehler{erNone, erOpen, erBreak};
enum dwWahr{dwFalse, dwTrue=-1};
enum osSystem{osUnDef, osWin9x, osNT, os2000};

DWORD OpenInterfaceRT(ftiDCB &Interface);
DWORD CloseInterfaceRT(ftiDCB &Interface);
DWORD GetInputsRT(ftiDCB &Interface);
DWORD GetAnalogRT(ftiDCB &Interface, DWORD AnalogNr);
