#ifndef umFishLoad_h
#define umFishLoad_h



// ----------------------------------------------------------------------------------------
//
// umFish20Load.h                                Andreas Stabinger / Ulrich Mller   6.9.01
//                                               C++Builder 5.0    / Procida 400NT VC++ 6.0
//
// Basisfunktionen fr die fischertechnik Interfaces (seriell und und parallel)
// Dynamisches Laden der umFish20.DLL
//
// -----------------------------------------------------------------------------------------

#include <windows.h>

typedef struct {
  HANDLE hCom;                 // --- PortHandle / Openflag ( = 0)
  DWORD PortID;                //     IO-Adresse bei LPT
  DWORD LPTDelay;              //     LPT Verzgerungsfaktor
  DWORD LPTAnalog;             //     LPT Analogfaktor 
  DWORD ECount;                //     Anzahl E-Eingnge (8/16)
	DWORD FID;                   // --- MultiMediaTimer Handle
	DWORD PollInterval;          //     Pollinterval des MM-Timers
	DWORD AnalogScan;            //     Pollen auch der Analogeingnge (0/1)
	DWORD OutputStatus;          // --- Status der M-Ausgnge
	DWORD InputStatus;           //     Status der E-Eingnge
  DWORD Analogs[2];            //     Werte der A-Eingnge
	DWORD Counters[16];          //     Impulszhler an den E-Eingngen
} ftiDCB;

HINSTANCE umFishLib;

// --- umFish20 : Funktionsprototypen --------------------------------------------

typedef DWORD (__stdcall *TOpenInterface) (ftiDCB &Interface, LPCSTR ComName);
typedef DWORD (__stdcall *TCloseInterface) (ftiDCB &Interface);
typedef DWORD (__stdcall *TVersion) ();
typedef BOOL  (__stdcall *TGetInput) (ftiDCB &Interface, DWORD InputNr);
typedef DWORD (__stdcall *TSetLamp) (ftiDCB &Interface, DWORD LampNr, DWORD OnOff);
typedef DWORD (__stdcall *TSetMotor) (ftiDCB &Interface, DWORD MotorNr, DWORD Direction);
typedef DWORD (__stdcall *TStartDriver) ();
typedef DWORD (__stdcall *TStopDriver) ();

// --- Konstanten ---------------------------------------------------------------

const DWORD ftiAus    = 0;
const DWORD ftiEin    = 1;
const DWORD ftiLinks  = 1;
const DWORD ftiRechts = 2;

const DWORD ftiFehler = 0x0001FFFF;

// --- Funktonen ----------------------------------------------------------------

TOpenInterface   umOpenInterface;
TCloseInterface  umCloseInterface;
TVersion         umGetVersion;
TGetInput        umGetInput;
TSetLamp         umSetLamp;
TSetMotor        umSetMotor;
TStartDriver     umStartDriver;
TStopDriver      umStopDriver;

// --- LadeRoutine LoadFish ------------------------------------------------------

BOOLEAN LoadFish(void)
{
  umFishLib = LoadLibrary("umFish20.DLL");
	if(!umFishLib) return FALSE;

	umOpenInterface  = (TOpenInterface)  GetProcAddress(umFishLib, "umOpenInterface");
	umCloseInterface = (TCloseInterface) GetProcAddress(umFishLib, "umCloseInterface");
	umGetVersion     = (TVersion)        GetProcAddress(umFishLib, "umGetVersion");
	umGetInput       = (TGetInput)       GetProcAddress(umFishLib, "umGetInput");
	umSetLamp        = (TSetLamp)        GetProcAddress(umFishLib, "umSetLamp");
	umSetMotor       = (TSetMotor)       GetProcAddress(umFishLib, "umSetMotor");
	umStartDriver    = (TStartDriver)    GetProcAddress(umFishLib, "umStartDriver");
	umStopDriver     = (TStopDriver)     GetProcAddress(umFishLib, "umStopDriver");
	return TRUE;
}

// --- UnloadRoutine FreeFish ----------------------------------------------------

void FreeFish(void)
{
	FreeLibrary(umFishLib);
	umFishLib = NULL;
	return;
}


#endif
