// ----------------------------------------------------------------------------
//
// frmFishMain(umFish20T.PAS/DFM)                         Ulrich Mller  5.3.00
//                                                        Procida 400NT Delphi4
// Testprogramm fr umFish20.DLL : Basisfunktionen zum Betrieb der
//                                fischertechnik Interfaces
// Lampen an M1 - M3 werden in einer Schleife an- und ausgeschaltet.
// Ende durch HALT-Button oder Taster E1,
// Unterbrechbarkeit : Application.ProcessMessages
// Zustzlich : Anzeige des Wertes von EX
//
// ----------------------------------------------------------------------------

unit umFish20T;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfrmFishMain = class(TForm)
    cmdStart: TButton;
    cmdHalt: TButton;
    cmdEnde: TButton;
    lblTitel: TLabel;
    lblCopyright: TLabel;
    Label1: TLabel;
    lblAwert: TLabel;
    lblPortName: TLabel;
    Label2: TLabel;
    procedure cmdEndeClick(Sender: TObject);
    procedure cmdHaltClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cmdStartClick(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

  var
     frmFishMain: TfrmFishMain;

implementation

{$R *.DFM}

uses umFish20;

var
  FishFace: TftiDCB;
  Stop: Boolean; PortName: string;

procedure TfrmFishMain.cmdEndeClick(Sender: TObject);
begin
     Self.Close;
end;

procedure TfrmFishMain.cmdHaltClick(Sender: TObject);
begin
  cmdStart.Enabled := true;
  cmdStart.SetFocus;
  cmdEnde.Enabled  := true;
  Stop := true;
end;

procedure TfrmFishMain.FormCreate(Sender: TObject);
begin
  Stop := true;
end;

procedure TfrmFishMain.cmdStartClick(Sender: TObject);

var i: Integer;

begin
  PortName := InputBox('umFish.DLL Test',
                       'Portname : COM1-4, LPT1-3, LPT (nur WinNT)', 'COM1');

  lblPortName.Caption   := PortName;
  FishFace.AnalogScan   := 1;
  FishFace.ECount       := 8;
  FishFace.PollInterval := 16;
  FishFace.LPTDelay     := 10;
  FishFace.LPTAnalog    := 5;

  if umOpenInterface(FishFace, PortName) = ftiFehler then begin
    MessageDlg('InterfaceProblem', mtInformation, [mbOK], 0);
    exit;
    end;
  lblTitel.Caption := lblTitel.Caption + ' Version ' + IntToStr(umGetVersion);
  cmdHalt.SetFocus;
  Stop := false;
  cmdStart.Enabled := false;
  cmdEnde.Enabled  := false;

  i := 1;
  repeat
    umSetMotor(FishFace, i, ftiLinks);
    lblAwert.Caption := format('%d', [FishFace.Analogs[0]]);
    Application.ProcessMessages;
    Sleep(300);
    umSetMotor(FishFace, i, ftiAus);
    Sleep(200);
    if i>=3 then i := 1 else i := i+1;
  until Stop or (umGetInput(FishFace, 1) = ftiTrue);
  umSetMotor(FishFace, 1, ftiAus);
  cmdEnde.Enabled  := true;
  cmdStart.Enabled := true;
  umCloseInterface(FishFace);
end;

end.
